
/*
	md6502 Version 0.04c ̉łB

		2012.10.25	2013.6.13	2014.4.14

					lemon	*/


/* If you comment out below semantic , this program outputs English Messages. */
#define MESSAGETYPE_JAPANESE

#include <stdio.h>
#include <string.h>

#define ACT_RW ( ACT_RD | ACT_WT )

#include "md6502.h"
#include "mdq-adr.h"
#include "mdq2-var.h"
#include "mdq2-label.h"
#include "mdq2-00-07.h"
//#include "mdq2-08-0F.h"
#include "mdq3-var.h"
#include "mdq3-label.h"
#include "mdq3-00-07.h"
//#include "mdq3-08-0F.h"
#include "mdq4-var.h"
#include "mdq4-label.h"
#include "mdq4-00-07.h"
//#include "mdq4-08-0F.h"

uchar	dq =3;
uint	file_size;
uchar	file_max;

//y[W0FŃAhXi8000~BFFF̂Ƃ́Ay[W̏B	//2015.3.24
uchar find_page_0F( ushort ad ) {
	int	j =0;
	uchar	p;
	ushort	a, b;
//return p=0;
	do {
		if (dq==2) {
			p =q2label0f[j].page;
			a =q2label0f[j].staddr;
			b =q2label0f[j].edaddr;
		} else if (dq==3) {
			p =q3label0f[j].page;
			a =q3label0f[j].staddr;
			b =q3label0f[j].edaddr;
		} else if (dq==4) {
			p =q4label0f[j].page;
			a =q4label0f[j].staddr;
			b =q4label0f[j].edaddr;
		} else { a=0xFFFF;b=0xFFFF; }
		if ( ad==a || (ad>a && ad<=b) ) return p;
		j++;
	} while (a != 0xFFFF);
}

//f[^擾
uchar getd( ushort addr, uchar page, uchar *buf ) {
	if ( addr<0x8000 ) return 0;
		else if ( addr < 0xC000 ) addr-=0x8000;
		else {
			addr-=0xC000;
			if ( (dq>2 && (page & 0x0F)!=0x0F) || (dq==2 && page!=0x07) ) if (dq==2) page=0x07; else page=0x0F;	//AhXC000ȍ~̂ƂŁAy[W0F, 1F ȊO̎́AIɃy[W0FŌvZB dq2̓y[W7̂݁B
		}
	//if ( addr +page *0x4000 >=file_size ) return 0xff;
	return	*( buf +addr +page *0x4000 );
}

//ꕶ擾
uchar get_moji( ushort *s, ushort *a, uchar p, uchar *buf ) {
	uchar	d;
	d =getd( *a, p, buf );
	if ( *s%4 == 0 ) d=d>>2;
	else if (*s%4 ==1 ) { d=(d & 3)<<4; (*a)++; d+= (getd( *a, p, buf )>>4 ); }
	else if (*s%4 ==2 ) { d= (getd( *a, p, buf ) & 0x0F )<<2; (*a)++; d+=(getd( *a, p, buf )>>6); }
	else if (*s%4 ==3 ) { d= d & 0x3F; (*a)++; }
	(*s)++;
	return	d;
}

//}bvOtBbN擾						//2015.7.19
int get_mapgra( int j, int i, uchar *ptnflg, uchar *buf ) {
	int	k;
	uchar	l;
	ushort	m, ad0, ad =i*24+0xA3F5;				//y5z[A3F5-AD33]}bvOtBbNentry (3B* )
	for( k=0; k<j; k++){
		l=getd( ad, 5, buf ); m=(l&3)*0x100 +getd( ad+1, 5, buf); l=l>>4; ad+=3;
//printf(":%04X,%02X, ",m,l);
		if ( l!=0x0F ) {
			ad0 =0xB412 +l*3;				//[B412-B43E]}bvOtBbN擾@
			for(l=0;l<4;l++){
				*(ptnflg +m)=1;
//printf("%04X,",m);
				m+=(char)getd( ad0, 5, buf ); ad0++;
			}
		} else {
			ad0 =m*5 +0xB2A0;				//y5z[B2A0-B3F3]OtBbNentryg
			l=getd( ad0, 5, buf ); ad0++;
			for(m=0;m<4;m++){
				*(ptnflg +(l&3)*0x100 +getd( ad0, 5, buf ))=1; ad0++; l>>2;
			}
		}
	}
}

//lOtBbN擾							//2015.7.20
int get_hitogra( int j, int i, uchar *ptnflg, uchar *buf ) {
	int	k;
	uchar	l;
	ushort	m, ad0, ad =i*24+0xADD8;				//y5z[ADD8-B29F]lOtBbNentry
	for( k=0; k<j; k++){
		l=getd( ad, 5, buf ); m=(l&3)*0x100 +getd( ad+1, 5, buf); l=l>>4; ad+=3;
//printf(":%04X,%02X, ",m,l);
		if ( l!=0x0F ) {
			ad0 =0xB43F +l*3;				//[B43F-B46B]lOtBbN擾@
			for(l=0;l<4;l++){
				*(ptnflg +m)=1;
//printf("%04X,",m);
				m+=(char)getd( ad0, 5, buf ); ad0++;
			}
		} else {
			ad0 =m*5 +0xB2A0;				//y5z[B2A0-B3F3]OtBbNentryg
			l=getd( ad0, 5, buf ); ad0++;
			for(m=0;m<4;m++){
				*(ptnflg +(l&3)*0x100 +getd( ad0, 5, buf ))=1; ad0++; l>>2;
			}
		}
	}
}

//ꕶo
uchar put_moji( uchar d, uchar daku, FILE *g ) {
	if ( d ==0xf7 ) daku =0x6A; else if ( d==0xf6 ) daku =0x6B;
	else if ( d<0x8D ) {
		fprintf( g, q3kana[d] );
		if ( daku ) { fprintf( g, q3kana[daku] ); daku =0; }
	} else fprintf( g, "%02X)",d );
	return daku;
}

//b\
int put_talk( ushort i, uchar *buf, FILE *g )
{
	uchar	p, d, c, flag=0, kana =0;
	ushort	a, r=0, s;

	//b# 0x800vXĂ΁AbZ[Wt@Cɏo͂Ƃ݂ȂAo͏ǉB
	if ( i>0x7ff ) { flag =1; i-=0x800; }

	//ԍ\
	fprintf( g, "yb#$%03Xz", i );
	if ( i>=0x02C0 && i<0x0300 ) { fprintf( g, "()" ); return -1; }		//0x02C0 - 0x02FF ͌ԁB

	//bf[^AhXoB
	if ( i<0x0351 ) p=0x0A;
	else if ( i<0x0360 ) { i = i -0x0351 +0x02C0; p=0x0B; }
	else if ( i<0x061E ) p=0x0B;
	else if ( i<0x0620 ) { i = i -0x061E +0x02E0; p=0x02; }
	else if ( i<0x0713 ) p=0x02;
	else return -1;					//0x0713 ȍ~͂Ƃ肠߂B
	a =getd( i/0x20 *2 +0xBBF2, 0x0E, buf ) +getd( i/0x20 *2 +0xBBF3, 0x0E, buf )*256;
	c = i%0x20;
	s=0;

	if (c) {
		while ( r<c ) {
			d =get_moji( &s, &a, p, buf );
			if ( d == 0x39 ) r++;
		}
	}

	if ( flag ) fprintf( g, "%04X,%02X,%04d\t", a, p, s );				//AhXAy[WA0x20ԂƂ̐擪牽ڂ ̕\B

	if ( i>=0x0200 ) fprintf( g, "u" );						//0x0200 ȍ~͉b`B


	//bf[^擾
	uchar	cp, cd, daku=0;
	ushort	ca;
	r =0;

	for(;;) {
		d =get_moji( &s, &a, p, buf );
		r++;
		if ( d ==0x39 || (!flag && r>100) ) if ( i%0x20 ==0x1f && flag ) { fprintf( g, "\t[Ōx]%03d", s ); return -1; } else return -1;
		if ( d <0x3C ) { 
			d =getd( 0xBB7A +kana +d, 0x0E, buf );
			daku =put_moji( d, daku, g );
		} else if ( d==0x3C ) { if ( kana ==0 ) kana =0x3C; else kana =0; }

		//kP
		else {
			d =((d & 3)-1) *0x40 +get_moji( &s, &a, p, buf );
			r++;
			fprintf( g, "[%02X:",d );	//Pԍ(00 -BF)

			//kPJnAhX
			ca =getd( d/0x20 *2 +0xBC64, 0x0E, buf ) +getd( d/0x20 *2 +0xBC65, 0x0E, buf )*256;
			cp =0x0A;
			c = d & 0x1f; d=0x00;

			//o
			if (c) {
				while ( d<c ) {
					if ( (cd =getd( ca, cp, buf )) ==0xFE ) d++;
					ca++;
				}
			}

			//ǂݍ
			while( (cd =getd( ca, cp, buf ))!=0xFE ) {
				if ( cd ==0xEF || cd ==0xFF ) { fprintf( g, "]" ); if ( i%0x20 ==0x1f && flag ) { fprintf( g, "\t[Ōx]%03d", s ); return -1; } else return -1; }
				daku =put_moji( cd, daku, g );
				ca++;
			}
			fprintf( g, "]" );
		}

	}
}

//bZ[W
int find_label(ushort ad, uchar page)		//Ԃlxԍ(Ȃꍇ́|1)
{
	int	j =0;
	char	p;
	ushort	a, b;
	
	if ( ad<0x8000 ) {
		do {
			if (dq==2) {
				a =q2mem7fff[j].staddr;
				b =q2mem7fff[j].edaddr;
			} else if (dq==3) {
				a =q3mem7fff[j].staddr;
				b =q3mem7fff[j].edaddr;
			} else if (dq==4) {
				a =q4mem7fff[j].staddr;
				b =q4mem7fff[j].edaddr;
			} else { a=0xFFFF;b=0xFFFF; }
			if ( ad==a || (ad>a && ad<=b) ) return j;
			j++;
		} while (a != 0xFFFF);

	} else{
		do {
			if (dq==2) {
				a =q2label[j].staddr;
				b =q2label[j].edaddr;
				p =q2label[j].page;
			} else if (dq==3) {
				a =q3label[j].staddr;
				b =q3label[j].edaddr;
				p =q3label[j].page;
			} else if (dq==4) {
				a =q4label[j].staddr;
				b =q4label[j].edaddr;
				p =q4label[j].page;
			} else { a=0xFFFF;b=0xFFFF; }

			if ( ad==a || (ad>a && ad<=b) ) {
				if ( page ==p ) return j;
				if (dq==4) {
					if ( page==0x0F && p==0x1F && (a>=0xC03D && a<0xE549 || a>=0xFF74) ) return j;	//DQ4Ńy[W 0Fh 1Fh̋ʕ́Ay[W 1FhɓB
					//if ( (page & 0x0F)==0x0F && (p & 0x0F )==0x0F ) return j;		//DQ4ŏLȊO0Fy[W1Fy[W͋ʂȂɒׂB
				}
			}
			j++;
		} while (a != 0xFFFF);
	}
	return -1;
}

//BRK߂̃R[AhXvZ
short chkbrk( uchar *dat, uchar page, uchar *buf ) {
	ushort	l,m;
	uchar	n =(*(dat+2) & 8)*2 +((*(dat+2) & 0xF0)>>4);
	uchar	a;

	if (dq==3) {
		if ( n<2 ) {
			if ( n ) { l=0xFCF0; m=0xFE3E; } else { l=0xFC70; m=0xFD3E; }
			a=getd( l+(*(dat+1)/2), 0x0F, buf );
			if ( *(dat+1) & 1) a =a &0x0F; else a =a>>4;
			l=0x8000+( getd( m+*(dat+1), 0x0F, buf ) )*2;
			l=getd( l, a, buf ) +getd( l+1, a, buf )*256;
		} else {
			l=getd( 0xEE6E +(n*2), 0x0F, buf ) +getd( 0xEE6F +(n*2), 0x0F, buf )*256;
			if ( l<0xC000 ) a=page; else a=0x0F;
		}
		*(dat+4)=a;			//ƂB
		return l;

	} else {
	//dq4̏ꍇ
		return 0;
	}

}

//1stAZu
uchar disasm6502( ushort addr, uchar page, uchar *buf, FILE *g, uchar p )
{
	ushort	i, i0;
	uchar	j;
	uchar	dat[5], k =page;
	int	la;

	uchar	uch0, uch1;
	char	ch0, ch1;

	// AhX̏o͂ƁAoCi1ڂ̏o
	la =0;
	*dat =getd( addr, page, buf );

	fprintf( g, "%04X : %02X", addr, *dat );
	j = dis6502[*dat].type & ADT_MASK;


	// oCi2ڈȍ~o
	for ( i = 1 ; i < *(opbytelength+j) ; i++ ) {
		*(dat+i) =getd( addr+i, page, buf );
		fprintf( g, " %02X", *(dat+i) );

		//߂4oCgȏォ𒲂ׂB
		if ( i==2 ) {
			i0=*(dat+1)+*(dat+2)*256;

			// DQ3 BRK
			if ( dq==3 && *dat==0x00 ) {
				i0=chkbrk(dat, page, buf);
				k=*(dat+4);			//chkbrk̈
				j=14;

			// DQ3 y[W0D  jsr +()1oCĝƂA4oCgڎ擾
			} else if ( dq==3 && *dat==0x20 && page==0x0D && ( i0==0xB050 || i0==0xB054 || i0==0xB058 || i0==0xB066 ||
				       i0==0xB06A || i0==0xB06E || i0==0xB0BE || i0==0xB0C5 || i0==0xB0CC || i0==0xB0D3 ) ) j =17;

			// DQ4 BRK
			else if ( dq==4 && *dat==0x00 ) {
				if ( (*(dat+2) & 7)==7 ) {
					k=(*(dat+2) & 8)*2 +((*(dat+2) & 0xF0)>>4);
					i0= getd( 0x8000+*(dat+1)*2, k, buf ) +getd( 0x8001+*(dat+1)*2, k, buf )*256;
					j=14;
					if ((*(dat+1)==0x07 || *(dat+1)==0x09) && *(dat+2)==0x6F ) j =15;			//$89A3,$16 (BRK)̌ĂяöPoCgǉBEEE
				}
				else if ( *(dat+2)==0x03 ) { i0=0x808A; k=0x10; j =14; }
				else if ( *(dat+2)==0x13 ) { i0=0x80C5; k=0x10; j =14; }
				else if ( *(dat+2)==0x23 ) { i0=0x80D1; k=0x10; j =15; }
				else if ( *(dat+2)==0x33 ) { i0=0x80D1; k=0x10; j =14; }
				else if ( *(dat+2)==0x43 ) { i0=0x80ED; k=0x10; j =15; }
				else if ( *(dat+2)==0x53 ) { i0=0x80ED; k=0x10; j =14; }
				else if ( *(dat+2)==0x63 ) { i0=0x810B; k=0x10; j =15; }
				else if ( *(dat+2)==0x73 ) { i0=0x810B; k=0x10; j =14; }
				else if ( *(dat+2)==0x83 ) { i0=0x812B; k=0x10; j =16; }
				else if ( *(dat+2)==0x93 ) { i0=0x812B; k=0x10; j =15; }
				else if ( *(dat+2)==0xA3 ) { i0=0xABAB; k=0x10; j =14; }
				else if ( *(dat+2)==0xB3 ) { i0=0xABBF; k=0x10; j =14; }
				else if ( *(dat+2)==0xC3 ) { i0=0xABD3; k=0x10; j =15; }
				else if ( *(dat+2)==0xD3 ) { i0=0x8157; k=0x12; j =15; }
				else if ( *(dat+2)==0xE3 ) { i0=0x8165; k=0x12; j =14; }
				else if ( *(dat+2)==0xF3 ) { i0=0x84B3; k=0x12; j =14; }	//F3 ͈oCgAmF

				else if ( (*(dat+2) & 0x0F)==0x0B && *(dat+2)<0xCB ) { i0=0x8028; k=0x16; j =14; }
				else if ( *(dat+2)==0xCB ) { i0=0xC4CA; k=0x1F; j =15; }
				else if ( *(dat+2)==0xDB ) { i0=0xC4E1; k=0x1F; j =15; }
				else if ( *(dat+2)==0xEB ) { i0=0xC4B6; k=0x1F; j =15; }
				else if ( *(dat+2)==0xFB ) { i0=0xC46C; k=0x1F; j =14; }
				else j =10;
			}
		}
	} i=i0;

	//^ȕo
	if ( *(opbytelength+j)< 4 ) fprintf( g, "\t" );

	// IyR[h̏o
	fprintf( g, "\t%s\t", dis6502[*dat].nimonic );

	// Iyh̏o
	switch ( *(opbytelength+j) ) {
		case 1:
			if ( dis6502[*dat].nimonic == opname[NMT_UND] ) fprintf( g, *(adtstring+ADT_IMM),*dat );	// `
			else	fprintf( g, *(adtstring+j) );								// 1byte
			break;
		case 2:
			if ( j == ADT_REL ) fprintf( g, *(adtstring+j), (i=addr +2 +(ch0 =*(dat+1))) );		// ΃AhX	//2̕␔vZ
			else	fprintf( g, *(adtstring+j), (i=*(dat+1)) );						// 2byte
			break;
		case 3:
			fprintf( g, *(adtstring+j), i, k );
			break;
		case 4:
			fprintf( g, *(adtstring+j), i, k, *(dat+3) );
			break;
		case 5:
			fprintf( g, *(adtstring+j), i, k, *(dat+3), *(dat+4) );
			break;
	}

	//TChRgǉ
	if ( j == ADT_NONE || j==ADT_AREG ) {
		la= -1;

	} else if ( j==ADT_IMM ) {
		la= -1;

		if ( dq==2 && *dat!=0x29 && *dat!=0x49 && *dat!=0x09 ) {
			if ( *(dat+1)<=108 ) fprintf( g, ";\tyMapz%s", q2map[*(dat+1)] );					//}bvID
			if ( *(dat+1)>0 && *(dat+1)<0x1A ) fprintf( g, "yȁz%s", q2bgm[*(dat+1)] );				//ID
			if ( *(dat+1)>0 && (*(dat+1) & 0x7F)<0x20 ) fprintf( g, "yz%s", q2snd[(*(dat+1) & 0x7F)] );		//ʉID
			if ( *(dat+1)<0x8d ) fprintf( g, "yz\'%s\'", q2kana[*(dat+1)] );					//ID
			if ( *(dat+1)<0x1e ) fprintf( g, "yz\'%s\'", q2win[*(dat+1)] );					//EBhEID
		} else if ( dq==3 && *dat!=0x29 && *dat!=0x49 && *dat!=0x09 && p!='s' ) {
			fprintf( g, ";\tyMapz%s", q3map[*(dat+1)] );								//}bvID
			if ( *(dat+1)>0 && *(dat+1)<0x27 ) fprintf( g, "yȁz%s", q3bgm[*(dat+1)] );				//ID
			if ( *(dat+1)>0 && (*(dat+1) & 0x7F)<0x24 ) fprintf( g, "yz%s", q3snd[(*(dat+1) & 0x7F)] );		//ʉID
			if ( *(dat+1)<0x8d ) fprintf( g, "yz\'%s\'", q3kana[*(dat+1)] );					//ID
			if ( *(dat+1)<102 ) fprintf( g, "yz\'%s\'", q3win[*(dat+1)] );					//EBhEID
		} else if ( dq==4 && *dat!=0x29 && *dat!=0x49 && *dat!=0x09 && p!='s' ) {
			if ( *(dat+1)<0x49 ) fprintf( g, ";\ty{݁z%s",q4map[*(dat+1)] );					//}bvID
			if ( *(dat+1)>0 && *(dat+1)<0x36 ) fprintf( g, "yȁz%s", q4bgm[*(dat+1)] );				//ID
			if ( *(dat+1)>0 && (*(dat+1) & 0x7F)<0x38 ) fprintf( g, "yz%s", q4snd[(*(dat+1) & 0x7F)] );		//ʉID
			if ( *(dat+1)<0x8d ) fprintf( g, "yz\'%s\'", q4kana[*(dat+1)] );					//ID
		} 
	} else if ( *dat==0x00 || *dat==0x4C || *dat==0x6C || *dat==0x20
		 || *dat==0x90 || *dat==0xB0 || *dat==0xF0 || *dat==0x30
		 || *dat==0xD0 || *dat==0x10 || *dat==0x50 || *dat==0x70) {

		//WvAhX$6B2F -$6C50 ̊Ԃ̏ꍇAWve[u (BRK xx 07 Ƌ)vZĐݒ肷B	DQ3̂
		if ( dq==3 && i>=0x6B2F && i<=0x6C50 ) {
			*(dat+1)=(i-0x6B2F)/5+0x23;
			*(dat+2)=0x07;
			*dat=0x00;			//y[W0D̂Ƃ̏ŃoOȂ悤ɁB
			i=chkbrk(dat, page, buf);
			k=*(dat+4);			//chkbrk̈
		}
		//aɂWv̂Ƃ
		if ( dq==3 && (getd( addr -2, page, buf ))==0xA9 ) {
			if ( ( i==0x6C51) || ( i==0x917C && page==0x0E ) ) uch0=0x23;
				else if ( i==0xC58B ) { fprintf( g,";a=(adr +x) " ); uch0=0x00;}
				else if ( (i==0xA11D || i==0xA0F1) && page==0x00 ) {

					//y[W0, $A11D, $A0F1փWv́AbZ[Wԍ000+a\B
					la =put_talk( getd( addr -1, page, buf ), buf, g ); la=-1; uch0=0xFF;

				} else uch0=0xFF;
			if ( uch0!=0xFF ) {
				*(dat+1)=(getd( addr -1, page, buf )) +uch0;
				*(dat+2)=0x07;
				*dat=0x00;			//y[W0D̂Ƃ̏ŃoOȂ悤ɁB
				i=chkbrk(dat, page, buf);
				k=*(dat+4);			//chkbrk̈
			}
		}

		//LȊO0x8000̎̓WvAhX͂̂܂܂ɂĂB
		//jump߂΍Xɂ̐𒲂ׂăRgBy[W܂ꍇ͕ۏ؊OB
		if ( i>=0x8000 ) for( ;; ) {
			if ( dq==2 && i>=0xC000 && getd( i, 0x07, buf ) ==0x4C && i!=(i0 =getd( i+1, 0x07, buf )+getd( i+2, 0x07, buf )*256) ) i=i0; 
			else if ( dq>=3 && i>=0xC000 && getd( i, 0x0F, buf ) ==0x4C && i!=(i0 =getd( i+1, 0x0F, buf )+getd( i+2, 0x0F, buf )*256) ) i=i0; 
			else if ( dq>=4 && i>=0xC000 && getd( i, 0x1F, buf ) ==0x4C && i!=(i0 =getd( i+1, 0x1F, buf )+getd( i+2, 0x1F, buf )*256) ) i=i0; 
			else if ( getd( i, k, buf ) ==0x4C && i!=(i0 =getd( i+1, k, buf )+getd( i+2, k, buf )*256) ) i=i0; 
			else break;
		}
	} else k=page;

	if ( i>=0xC000 ) if ( dq==3 || page==0x0f) k=0x0F; else if (dq==2) k=0x07; else k=0x1f;

	if ( la!=-1 ) {
		if ( getd( i, k ,buf )==0x60 ) fprintf( g, ";rts\t" ); else if ( i<0x8000 || i>=0xC000 || k==page ) fprintf( g, ";%4X\t", i ); else fprintf( g, ";%4X,%2X", i, k );
		if ( k==0x0F && i>=0x8000 && i<0xC000 ) k=find_page_0F( addr );		//y[W0FŃAhXi8000~BFFF̂Ƃ́Ay[W̏B	//2015.3.24
		la=find_label( i, k );		//Ԃlxԍ(Ȃꍇ́|1)
	}

	//(BRK yy 2F) a=yy, 	85C1,1	BGM擪AhXݒ&ϐ&e|ݒ`@̂ƂB
	if ( dq==3 && *dat==0x00 && *(dat+2)==0x2F ) {
		if ( *(dat+1) <0x26 ) fprintf( g, "yBGM%2Xz%s", *(dat+1), q3bgm[*(dat+1)] );
			else	fprintf( g, "ySND%2Xz%s", (*(dat+1) & 0x7F), q3snd[(*(dat+1) & 0x7F)] );
	}

	//(BRK yy FB) a=yy, 	$EF59	BGM擪AhXݒ&ϐ&e|ݒ`@̂ƂB
	if ( dq==4 && *dat==0x00 && *(dat+2)==0xFB ) {
		if ( *(dat+1) <56 ) fprintf( g, "yBGM%2Xz%s\t", *(dat+1), q4bgm[*(dat+1)] );
			else if ( *(dat+1)>=0x80 && *(dat+1)<0x80+56 ) fprintf( g, "ySND%2Xz%s\t", (*(dat+1) & 0x7F), q4snd[(*(dat+1) & 0x7F)] );
	}

	// y[W0x0DŁA4oCgJSR߂̏ꍇAbZ[We\B
	if ( dq==3 && *dat==0x20 && page==0x0D ) {
		i=*(dat+1)+*(dat+2)*256;
		if ( i==0xB050 ) { i=0x300; j=13; }		//i =basebԍ, j =b7tO b6tO +4oCg
		else if ( i==0xB054 ) { i=0x3F7; j=0x0D; }
		else if ( i==0xB058 ) { i=0x4F7; j=0x0D; }
		else if ( i==0xB066 ) { i=0x300; j=0x8D; }
		else if ( i==0xB06A ) { i=0x3F7; j=0x8D; }
		else if ( i==0xB06E ) { i=0x4F7; j=0x8D; }
		else if ( i==0xB0BE ) { i=0x5B5; j=0xCD; }
		else if ( i==0xB0C5 ) { i=0x6B5; j=0xCD; }
		else if ( i==0xB0CC ) { i=0x5B5; j=0x4D; }
		else if ( i==0xB0D3 ) { i=0x6B5; j=0x4D; }
		if ( (j & 0x0F) ==0x0D ) {
			if ( (j & 0x40)==0x40 ) fprintf( g, "(Party,Leader,Sex,Status)" );
			if ( (j & 0x80)==0x80 ) fprintf( g, "bI" ); else fprintf( g, "bp" );
			la =put_talk( i+ *(dat+3), buf, g ); la=-1;
			j=0x0D;
		}
	} else if ( dq==3 && *dat==0x00 ) {

	// (brk) b̏ꍇAbZ[We\B
		if ( *(dat+2)==0x67 || *(dat+2)==0x97 ) { i=0x000; la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0x0F ) { i=0x000; fprintf( g, "**** 퓬mesI **"); la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0xF7 ) { i=0x000; fprintf( g, "**** 퓬mesp **"); la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0x77 || *(dat+2)==0xA7 ) { i=0x100; la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0x87 || *(dat+2)==0xB7 ) { i=0x200; la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0x3F ) { i=0x600; la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0x1F ) { i=0x700; la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0xC7 ) { i=0x800; la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0x27 ) { i=0x5B5; fprintf( g, "(5B5+),bp"); la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0x37 ) { i=0x6B5; fprintf( g, "(6B5+),bp"); la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0x47 ) { i=0x5B5; fprintf( g, "(5B5+),bI"); la =put_talk( i+ *(dat+1), buf, g ); la=-1; }
		else if ( *(dat+2)==0x57 ) { i=0x6B5; fprintf( g, "(6B5+),bI"); la =put_talk( i+ *(dat+1), buf, g ); la=-1; }

	// (brk) EBhȄꍇ
		else if ( *(dat+2)==0xD7 || *(dat+2)==0xE7 ) fprintf( g, "yz\'%s\'\t", q3win[*(dat+1)] );					//EBhEID

	} else if ( dq==4 && *dat==0x00 ) {

	// (brk) EBhȄꍇ
		if ( *(dat+1)==0x07 && *(dat+2)==0x6F && *(dat+3)<0x60 ) fprintf( g, "yz\'%s\'\t", q4win[*(dat+3)] );					//EBhEID

	}

	//TChRg

	if ( la==-1 ) {
	} else if ( i<0x8000 ) {
		if (dq==2) fprintf( g, ";%s", q2mem7fff[la].comment );
			else if (dq==3) fprintf( g, ";%s", q3mem7fff[la].comment );
			else if (dq==4) fprintf( g, ";%s", q4mem7fff[la].comment );
	} else {
		if (dq==2) { i0=q2label[la].staddr; i=q2label[la].edaddr; }
			else if (dq==3) { i0=q3label[la].staddr; i=q3label[la].edaddr; }
			else if (dq==4) { i0=q4label[la].staddr; i=q4label[la].edaddr; }
		if (i>=i0) fprintf( g, "[%04X-%04X]",i0 ,i );
		if (dq==2) fprintf( g, ";%s", q2label[la].comment );
			else if (dq==3) fprintf( g, ";%s", q3label[la].comment );
			else if (dq==4) fprintf( g, ";%s", q4label[la].comment );

		//f[^̎Ae\B(\)
		if (i>=i0) fprintf( g, " ;" );

	}

	if(*dat==0x40 || *dat==0x4C || *dat==0x60 || *dat==0x6C ) fprintf( g, "\n" );		//rts, jmp Ȃǂ́AsĊԂ󂯂B

	return *(opbytelength+j);
}


int main(int argc, char *argv[])
{
	FILE	*f, *g, *h;
	char	fname[20]="";
	uchar	buf[0x80000], page;

	ushort	base, addr,branch[32];
	ushort	*bp;
	long	len;
	uint	i, j, offset;
	int	la;
	uchar	di;

	char	mes00[] = {"DQ3 ܂ DQ4 ̃t@C"};
	char	mes01[] = {"wb_[ǂݎ܂B\n"};
	char	mes02[] = {"t@CĂ܂B\n"};
	char	mes03[] = {"ł͂܂B\n"};
	char	mes04[] = {" I[v\n"};

	char	header3[] = { 0x4E, 0x45, 0x53, 0x1A, 0x10, 0x00, 0x23, 0x00 };
	char	header4[] = { 0x4E, 0x45, 0x53, 0x1A, 0x20, 0x00, 0x13, 0x00 };

	char	*q;
	uchar	p;
	ushort	a, b;

//DQC[W`FbN

	if ( argv[1] == NULL ) {
		printf("%sɎwA邢́AACRɃhbOhbvĂB\n",mes00);
		return 0;
	}

	if ((f = fopen(argv[1],"rb")) == NULL) { printf("%sI[vł܂B\n",argv[1]); return -1; }
	if (fscanf(f,"%08c",fname)==EOF) { printf("%s",mes01); fclose(f); return 0; }

	if (!strcmp(fname, header3)) {
		if (fseek(f,0x3FFF0,SEEK_SET)) { printf("%s",mes02); fclose(f); return 0; }
		if (fscanf(f,"%16c",fname)==EOF) { printf("%s",mes02); fclose(f); return 0; }
		if (strcmp(fname, "DRAGON QUEST III")) { printf("%s%s",mes00,mes03); fclose(f); return 0; }
		file_max =16; dq =3; file_size =0x40000;

	} else if (!strcmp(fname, header4)) {
		if (fseek(f,0x7FFF0,SEEK_SET)) { printf("%s",mes02); fclose(f); return 0; }
		if (fscanf(f,"%16c",fname)==EOF) { printf("%s",mes02); fclose(f); return 0; }
		if (strcmp(fname, "DRAGON QUEST IV ")) { printf("%s%s",mes00,mes03); fclose(f); return 0; }
		file_max =32; dq =4; file_size =0x80000;
	} else { 
		dq=2;file_size=0x20000;file_max=8;
//printf("%s%s",mes00,mes03); fclose(f); return 0; }
	}
	printf("dq%1d%s", dq, mes04);

//DQC[W̃[h

	fseek( f, 0x10,SEEK_SET );
	if ( fread( buf, 1, file_size, f ) <file_size ) { printf( "t@C̓ǂݍ݂Ɏs܂B\n" ); fclose(f); return 0; }

//x쐬pAhXt@C̃I[v

	sprintf( fname,"dq%1d-label-adr.txt",dq);
	h = fopen( fname,"w");

//DQ34 C

	offset = 0;				// ItZbg

	for (page =0; page <file_max; page++ ) {
		fprintf( h, "\n;page0x%02X\n", page );

		if ( page == 0x0F || page == 0x1F || (dq==2 && page==0x07)) base = 0xC000; else base = 0x8000;
		addr = 0x0000;
		offset = page * 0x4000;
		sprintf( fname, "dq%1d-%01X-%1X-%05X.txt", dq, page/0x10, page&0x0F, offset );
		g = fopen( fname,"w");


	#ifdef MESSAGETYPE_JAPANESE
		printf("y[W%02X tAZu͈:%04X - %04X\n", page, base,base+0x3FFF);
	#else
		printf("Disassemble renge:%04X - %04X\n",base,base+0x3FFF);
	#endif
		if ( !g ) {
	#ifdef MESSAGETYPE_JAPANESE
			fprintf(stderr,"o̓t@C ܂łB\n");
	#else
			fprintf(stderr,"Can't write file.\n");
	#endif
			return 0;
		}
		p=0;
		bp=&(branch[0]);

		for ( addr = 0 ; addr < 0x4000 ; ) {
			//̃Rg
			// f[^̈
			if ( bp==&(branch[0]) ) { *bp=base+addr; bp++; }

			len=0;
			if ( (la = find_label(addr+base, page) ) != -1 ){			//Ԃlxԍ(Ȃꍇ́|1)

				//if ( !p ) fprintf( h,"%04X\n",base+addr );
				
				if (dq==2) {
					q =q2label[la].comment;
					a =q2label[la].staddr;
					b =q2label[la].edaddr;
					p =q2label[la].unit;
				} else if (dq==3) {
					q =q3label[la].comment;
					a =q3label[la].staddr;
					b =q3label[la].edaddr;
					p =q3label[la].unit;
				} else if (dq==4) {
					q =q4label[la].comment;
					a =q4label[la].staddr;
					b =q4label[la].edaddr;
					p =q4label[la].unit;
				} else { b=0;p='s'; }


				if ( b ){
					fprintf( g, ";[%04X-%04X]%s\n", a, b, q );
					for(  ; addr+base <=b ; len++ ){
						if ( p =='b' ){
							if ( !(len%0x10) ) fprintf( g, "%04X : db ",base+addr );
							fprintf( g, "$#%02X", getd( addr+base, page, buf ) );
							if ( !((len+1)%0x10) || addr+base==b) fprintf( g, "\n" ); else fprintf( g, ", " );
							addr++;
						} else if (p =='w'){
							if ( !(len%0x08) ) fprintf( g, "%04X : dw ",base+addr );
							fprintf( g, "$%04X", getd( addr+base, page, buf )+getd( addr+1+base, page, buf )*256 );
							if ( !((len+1)%0x08) || addr+base>=b-1) fprintf( g, "\n" ); else fprintf( g, ", " );
							addr+=2;
						} 
					}
				} else if ( p!='s' ) fprintf( g, ";%s\n", q );
			}
			if ( len == 0 ) {
				// tAZu
				di = disasm6502( base+addr, page, buf, g, p );
				
				if (p=='s') fprintf( g, "yz%s", q );		//TChRg

				addr += di;
			}
			if ( (p=getd( base+addr-di, page, buf ))==0x40 || p==0x4C || p==0x60 || p==0x6C ) { fprintf( h,"%04X\n",base+addr ); p=0xFF; } else p=0;
			//p=' ';
			fprintf( g, "\n" );
		}
		fclose(g);
	}

	//f[^̍vTCY߂
	printf( "\nvOTCY:f[^TCY(byte)");
	j=0;p=0;offset=0;
	for( i=0; ( dq==3 && q3label[i].staddr!=0xffff) || ( dq==4 && q4label[i].staddr!=0xffff); i++ ) {
		if ( dq==3 && p!=q3label[i].page ) { printf( "\nPage %02X, (P) 0x%04X (D) 0x%04X", p, 0x4000-(j-offset), j-offset ); p=q3label[i].page; offset=j; }
		if ( dq==4 && p!=q4label[i].page ) { printf( "\nPage %02X, (P) 0x%04X (D) 0x%04X", p, 0x4000-(j-offset), j-offset ); p=q4label[i].page; offset=j; }

		if ( dq==3 && q3label[i].edaddr!=0x0000 ) j+=q3label[i].edaddr -q3label[i].staddr +1;
		else if ( dq==4 && q4label[i].edaddr!=0x0000 ) j+=q4label[i].edaddr -q4label[i].staddr +1;
	}
	printf( "\nPage %02X, (P) 0x%04X (D) 0x%04X", p, 0x4000-(j-offset), j-offset );
	if (dq==3) i =0x40000 -j; else i =0x80000 -j;
	printf( "\nvOTCY v 0x%05X byte\n", i );
	printf( "f[^TCY     v 0x%05X byte\n", j );

	//bAbZ[Wꗗt@Co

	if ( dq==3 ) {
		g = fopen( "dq3bbZ[Wꗗ.txt", "w");
		fprintf( g, "yb ԍzaddr p x\n" );
		for( a=0; a<0x713 ;a++ ) {
			if ( !(a%0x20) ) fprintf( g, "\n" );
			la =put_talk( a+0x800, buf, g );
			fprintf( g, "\n" );
		}
		fclose(g);
		printf("\ndq3bbZ[Wꗗ.txtt@Co\n");

	//X^[f[^ꗗt@Co

		g = fopen( "dq3X^[f[^ꗗ.txt", "w");

		//fprintf( g, "yb ԍzaddr p x\n" );

		uchar	monID,monWidth, mNumber,e,d,f, numBG, numSPR;
		ushort	mPatternAdr, mStartAdr, mPaletteAdr,mNameAdr=0x86DF;
		

		for( monID=0; monID<139 ;monID++ ) {

			mNumber= getd( 0x8EC3+monID*5, 0x02, buf );
			mPatternAdr= getd( 0x8EC3+monID*5+1, 0x02, buf )+getd( 0x8EC3+monID*5+2, 0x02, buf )*256; mStartAdr=mPatternAdr;
			mPaletteAdr= getd( 0x8EC3+monID*5+3, 0x02, buf )+getd( 0x8EC3+monID*5+4, 0x02, buf )*256;
			page= 0x02 +( (getd( 0x8EB1+monID/8, 0x02, buf ) >>(7-monID%8)) & 1);
			fprintf( g, "%-3d (0x%02X) ",monID, monID );

			//[86DF-8988,0A](diff,I[FF)X^[ID 00h - 53h ̖̎Of[^ (F6_ F7_)
			for( p=0;p<12;p++ ){
				d=getd( mNameAdr, 0x0A, buf );
				mNameAdr++;
				if (d==0xFF) break;
				if (d==0xF7 || d==0xF6 ) {e=0x6A+((d+1)&1);d=getd( mNameAdr, 0x0A, buf );mNameAdr++;p++;} else e=0;
				fprintf( g,q3kana[d]);
				if (e) fprintf( g,q3kana[e]);
			}
			for(;p<12;p++) fprintf( g,"@");
			fprintf( g, "p^[adr:0x%04X,%02X pbgadr:0x%04X,02 \n", mPatternAdr, page, mPaletteAdr );

			//X^[pbg
			d=getd( mPaletteAdr,0x02,buf);
			mPaletteAdr++;
			fprintf( g,"	SPRpbg %01d:",d & 0x0F );
			if ( d & 0x0F) for( p=0;p<(d &0x0F)*3;p++) { fprintf( g," %02X",getd( mPaletteAdr,0x02,buf ));mPaletteAdr++; if(p%3==2)fprintf(g,",");}
			fprintf(g,"\n");
			d=(d & 0xF0)>>4;
			fprintf( g,"	BGpbg  %01d:",d );
			if ( d ) for( p=0;p<d*3;p++) { fprintf( g," %02X",getd( mPaletteAdr,0x02,buf ));mPaletteAdr++; if(p%3==2)fprintf(g,",");}

			//X^[p^[
			numBG=0;numSPR=0;f=0;
			fprintf( g, "\n\n\tp^[f[^:%2d (*̐)\n\t(x,y)= ",mNumber );
			for( ;mNumber>0;mNumber--){
				fprintf( g,"*");
				do {
					d=getd( mPatternAdr,page,buf);mPatternAdr++;
					e=getd( mPatternAdr,page,buf);mPatternAdr++;
					if ( d & 0x04 ) fprintf( g,"㉺");
					if ( d & 0x02 ) fprintf( g,"E");
					if ( d & 0x40 ) fprintf( g,"BG(%1d,%1d), ",e & 0x0F, (e & 0xF0)>>4 );
						else { fprintf( g,"SPR(0x%02X,0x%02X), ", e, getd( mPatternAdr,page,buf) ); mPatternAdr++; }
					if ( !((++f)%10) ) fprintf( g, "\n\t" );
				} while( !(d & 0x80) );

				//̃p^[adri߂B
				if ( d & 0x01 ) { e=getd( mPatternAdr,page,buf);mPatternAdr++; }
				if ( d & 0x08 ) {
					a =getd( mPatternAdr,page,buf)+getd( (mPatternAdr+1),page,buf)*256;mPatternAdr+=2;
					//fprintf( g,"** %04X ** ",a );
					for(p=0;p<16;p++) {
						if( a & 1 ) mPatternAdr++;
						a=a>>1;
					}
				} else mPatternAdr+=16;
			}
			fprintf(g,"\n\tp^[f[^TCY 0x%04X\n\n",mPatternAdr-mStartAdr );
		}

		fclose(g);
		printf("\ndq3X^[f[^ꗗ.txtt@Co\n");


	//}bvOtBbNf[^ꗗt@Co					//2015.7.18

		g = fopen( "dq3}bvgraphicf[^ꗗ.txt", "w");

		uchar	usegra;
		uchar	ptnflg[920];
		ushort	c,c1;

		for( usegra=0; usegra<0x1C ;usegra++ ) {
			fprintf(g, "\n}bv摜Q 0x%02X\n", usegra);
			for( i=0;i<920;i++ ) ptnflg[i]=0;
			c1=0;
			if( !usegra ) {
				i=0x12;
				get_mapgra( 32, i, ptnflg, buf );			//}bvOtBbN擾
			} else if ( usegra>=9 ) {
				i=(usegra-8)*4+0x12;
				get_mapgra( 32, i, ptnflg, buf );			//}bvOtBbN擾
			} else {
				get_mapgra( 8, usegra*2, ptnflg, buf );			//}bvOtBbN擾
				get_mapgra( 8, 0, ptnflg, buf );			//}bvOtBbN擾
				get_mapgra( 8, usegra*2+1, ptnflg, buf );		//}bvOtBbN擾
				get_mapgra( 8, 1, ptnflg, buf );			//}bvOtBbN擾
			}
			a=0xFFFF;b=0xFFFF;c=0;
			for( i=0; i<920;i++ ) {
				if ( ptnflg[i] ) {
					b=i; if (a==0xFFFF) a=i;
				} else {
					if (a!=0xFFFF) { fprintf(g, "%04X`%04X(%04X), ",a*0x10 ,b*0x10, (b-a+1)*0x10 ); a=0xFFFF; }
				}
			}
			fprintf(g,"\n");
			
			for( i=112; i<920;i++ ) {
				if ( ptnflg[i] ) {
					if ( !c ) {
						c=1; j=i;
					} else {
						if ( c==0x20 ) {
							fprintf(g, "%04X`%04X[%04X], ",j*0x10, (j+c-1)*0x10, c*0x10 );
							c1+=c*0x10;
							c=1; j=i;
						} else {
							c*=2;i=j+c-1;
						}
					}
				} else {
					if ( c ) {
						fprintf(g, "%04X`%04X[%04X], ",j*0x10, (j+c-1)*0x10, c*0x10 );
						c1+=c*0x10;
						c=0;
					}
				}
			}
			fprintf(g,"\n[v %04XoCg]\n",c1);
		}
		fclose(g);
		printf("\ndq3}bvgraphicf[^ꗗ.txtt@Co\n");

	//lOtBbNf[^ꗗt@Co					//2015.7.20

		g = fopen( "dq3lgraphicf[^ꗗ.txt", "w");

		for( usegra=0; usegra<0x33 ;usegra++ ) {
			fprintf(g, "\nl 0x%02X\n", usegra);
			for( i=0;i<948;i++ ) ptnflg[i]=0;
			get_hitogra( 8, usegra, ptnflg, buf );			//lOtBbN擾

			a=0xFFFF;b=0xFFFF;
			for( i=0; i<948;i++ ) {
				if ( ptnflg[i] ) {
					b=i; if (a==0xFFFF) a=i;
				} else {
					if (a!=0xFFFF) { fprintf(g, "%04X`%04X(%04X), ",a ,b, b-a+1 ); a=0xFFFF; }
				}
			}
			fprintf(g,"\n");
		}
		fclose(g);
		printf("\ndq3lgraphicf[^ꗗ.txtt@Co\n");

	}

/*
	uchar	zz;
	ushort	zi, za,zb;
	printf("talk\n");
	for(zz=0;zz<22;zz++){
	za =getd( 0xBBF2 +zz*2, 0x0E, buf ) +getd( 0xBBF3 +zz*2, 0x0E, buf )*256;
	zb =getd( 0xBBF4 +zz*2, 0x0E, buf ) +getd( 0xBBF5 +zz*2, 0x0E, buf )*256;
	printf("0x%04X	",zb-za);
	}
	printf("\n");
	for(zz=24;zz<27;zz++){
	za =getd( 0xBBF2 +zz*2, 0x0E, buf ) +getd( 0xBBF3 +zz*2, 0x0E, buf )*256;
	zb =getd( 0xBBF4 +zz*2, 0x0E, buf ) +getd( 0xBBF5 +zz*2, 0x0E, buf )*256;
	printf("0x%04X	",zb-za);
	}
	printf("\n");
	for(zz=27;zz<49;zz++){
	za =getd( 0xBBF2 +zz*2, 0x0E, buf ) +getd( 0xBBF3 +zz*2, 0x0E, buf )*256;
	zb =getd( 0xBBF4 +zz*2, 0x0E, buf ) +getd( 0xBBF5 +zz*2, 0x0E, buf )*256;
	printf("0x%04X	",zb-za);
	}
	printf("\n");
	for(zz=49;zz<57;zz++){
	za =getd( 0xBBF2 +zz*2, 0x0E, buf ) +getd( 0xBBF3 +zz*2, 0x0E, buf )*256;
	zb =getd( 0xBBF4 +zz*2, 0x0E, buf ) +getd( 0xBBF5 +zz*2, 0x0E, buf )*256;
	printf("0x%04X	",zb-za);
	}
*/

	fclose(f);
	return 0;
}


